/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.shop.utils;

import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicLong;

public class TimingQueue<E>
extends LinkedBlockingQueue<E> {
    private static final long serialVersionUID = -818906940627447482L;
    private AtomicLong lastPollTime = new AtomicLong(0L);

    public TimingQueue(int capacity) {
        super(capacity);
    }

    public E poll(long timingTime, long timeout, TimeUnit unit) throws InterruptedException {
        if (!this.checkTime(timingTime, unit)) {
            return null;
        }
        return super.poll(timeout, unit);
    }

    @Override
    public E poll(long timingTime, TimeUnit unit) {
        if (!this.checkTime(timingTime, unit)) {
            return null;
        }
        return this.poll();
    }

    public E take(long timingTime, TimeUnit unit) throws InterruptedException {
        if (!this.checkTime(timingTime, unit)) {
            return null;
        }
        return this.take();
    }

    private boolean checkTime(long timingTime, TimeUnit unit) {
        Long currTime;
        long tmp = this.lastPollTime.get();
        if (tmp > (currTime = Long.valueOf(System.currentTimeMillis()))) {
            this.lastPollTime.set(currTime);
            return true;
        }
        if (tmp > 0L && currTime - tmp < timingTime) {
            return false;
        }
        this.lastPollTime.set(currTime);
        return true;
    }
}

